#
# spec file for package cgit
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define git_version	1.7.3.4

Name:           cgit
Url:            http://hjemli.net/git/cgit/
License:        GPLv2
Group:          Development/Libraries/C and C++
AutoReqProv:    on
Version:        0.8.3.3
Release:        5.7.1
Summary:        A web frontend for git repositories
Source0:        %{name}-%{version}.tar.bz2
Source1:        git-%{git_version}.tar.bz2
Source2:        cgitrc
Patch0:         cgit-link-fixes.diff
Patch1:         cgit_fix_stringlist.patch
Patch2:         cgit-CVE-2011-2711-fix.diff
# Requirements for cgit
BuildRequires:  git >= 1.7.1
BuildRequires:  gnu-crypto libopenssl-devel libzip-devel
# Requirements for cgitrc man page generation
BuildRequires:  asciidoc libxslt
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This is an attempt to create a fast web interface for the git scm, using a
builtin cache to decrease server io-pressure.

Authors:
--------
    Lars Hjemli (hjemli@gmail.com)

%prep
%setup -q
%setup -q -T -D -a 1
rm -rf git
mv git-%{git_version} git
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
make
make man-doc

%install
make install CGIT_SCRIPT_PATH="%{buildroot}"/srv/www/htdocs/cgit

mkdir -p "%{buildroot}"/srv/www/cgi-bin/cgit/
mv "%{buildroot}"/srv/www/{htdocs,cgi-bin}/cgit/cgit.cgi

mkdir -p "%{buildroot}%{_mandir}"/man5/
cp cgitrc.5 "%{buildroot}%{_mandir}"/man5/cgitrc.5

mkdir -p "%{buildroot}"/etc
cp %{SOURCE2} "%{buildroot}"/etc/cgitrc

%clean
make clean

%files
%defattr(-,root,root)
%dir /srv/www/htdocs/cgit
%dir /srv/www/cgi-bin/cgit
/srv/www/cgi-bin/cgit/cgit.cgi
/srv/www/htdocs/cgit/cgit.css
/srv/www/htdocs/cgit/cgit.png
%doc %{_mandir}/man5/cgitrc.5.gz
%config(noreplace) /etc/cgitrc

%changelog
* Fri Aug  5 2011 tiwai@suse.de
- Fix VUL-0: cgit: XSS flaw in rename hint (CVE-2011-2711,
  bnc#707929)
* Fri Dec 17 2010 tiwai@suse.de
- updated to git 1.7.3.3:
  In addition to the usual fixes, this release also includes
  support for the new "add.ignoreErrors" name given to the
  existing "add.ignore-errors" configuration variable.
- updated to git 1.7.3.4:
  Among many fixes since v1.7.3.3, it contains a fix to a recently
  discovered XSS vulnerability in Gitweb (CVE 2010-3906)
* Thu Sep 30 2010 tiwai@suse.de
- updated to git 1.7.3:
  major version update; new options and behavior for git-rebase,
  git-clean, git-checkout, git-gui.
  See release note:
  http://www.kernel.org/pub/software/scm/git/docs/RelNotes-1.7.3.txt
- updated to git 1.7.3.1:
  fix git-stash breakages
- Set NO_CROSS_DIRECTORY_HARDLINKS=1 to satisfy BS
* Fri Aug 20 2010 anschneider@exsuse.de
- fixed more segfaults in cgit.
* Fri Aug 20 2010 anschneider@exsuse.de
- fix cgit segfault when using git > 1.7
- update to version 0.8.3.3
- get debuginfo working, don't strip binaries.
* Fri Aug 20 2010 tiwai@suse.de
- updated to git 1.7.2.2
* Thu Jul 29 2010 tiwai@suse.de
- fix missing link with libpthread
* Thu Jul 29 2010 tiwai@suse.de
- updated to git 1.7.2.1: minor fixes for git-instaweb, git-web,
  git-config.  See release note:
  http://www.kernel.org/pub/software/scm/git/docs/RelNotes-1.7.2.1.txt
* Thu Jul 22 2010 tiwai@suse.de
- updated to git 1.7.2: mostly bug fixes and small enhancements;
  see the release note:
  http://www.kernel.org/pub/software/scm/git/docs/RelNotes-1.7.2.txt
- gitweb stuff is moved to /usr/share/gitweb
* Sun Apr 25 2010 poletti.marco@gmail.com
- Build against version 1.7.0.3 of git instead of 1.6.4.3.
* Fri Feb  5 2010 poletti.marco@gmail.com
- Initial release, version 0.8.3.1
